MultiTaper.v4 <-
function (startX, endX, Avg=1, lum=4, sizePts=2, binPts=15,Rverbose=0,myData,fileName,Span, Increment) {
#  starting column, ending column, Average or Individual, #minutes between points, # points to bin, # minutes/unit (usually day)
# require delftfews, multitaper, chron, zoo?
  #require(delftfews)
  #require(multitaper)
  #require(seewave)
  modulo = 1440
  startData<-1
 
  CatBins<-CatBin(startX, endX, Avg, lum, sizePts, binPts,modulo, startData,myData)
  # returns newMinPerBin,dataPts,binsPerDay,animals, startData, endData, DataList,plotCnt

  DataList<-CatBins$DataList
  op<-par()
  thisTime <- format(Sys.time(), "%b %d, %Y - %H:%M:%S");
  nameVector = paste(" ",names(myData),sep=" ")

for (cnt in 1:CatBins$plotCnt) {      #  1 plot per animal, for all animals 

  # 4 figures in one column
  # row 1,2,3 are 1/3 the height of row 4
  layout(matrix(c(1,2), 2, 1, byrow = TRUE), 
         widths=c(1), heights=c(1,2))
  par(mar=c(4,4,2,1), oma=c(2,0,1,0))         # set up margins

  # Use the periodogram
  CatPeriodogram<- CatPeri(DataList[cnt,],binsPerHr=CatBins$binsPerDay/24, Hx=.2, cex=.75, Debug=FALSE)    # get Units working
  
  n<-length(DataList[cnt,])
  nfft<-(n/2)+1
  
 #------------------------
  
  if (Avg)  {    
    title(paste('Start time:',myData[CatBins$startData,1],';    End time:',myData[CatBins$endData,1],'\nAvg across -',CatBins$animals,'- Animals: ',nameVector[startX],' - ',nameVector[endX]),cex=.7)
  } else {
    title(paste('Start time:',myData[CatBins$startData,1],';    End time:',myData[CatBins$endData,1],'\nAnimal -',cnt,': ',nameVector[cnt+3]),cex=.7)
  }  
  
  #--par(opar)   #restore margines
  #--op<-par()   #save margins
  #NW=3 works well;  4 is a little too wide
  NWmtm <- 3           #   2*4*1800   # (where 1800 = 60s x #bins)
  Kmtm <- NWmtm*2-1     #  nw=4;k=1000 gives error k<= 1.5+2*nw......nw=4;k=4 mod narrower...nw=4;k=3 matches periodogram
  #  nw=100;k=100: w> 1/2....nw=50 all one curve...
  #getMT = spec.mtm(DataList[cnt,],nw=NWmtm, k=Kmtm, Ftest=T, main="Multitaper",dtUnits="day",dT=(CatBins$newMinPerBin/60/24),col='orange',xlab="")
  getMT = spec.mtm(DataList[cnt,],nw=NWmtm, k=Kmtm, Ftest=T, main="Multitaper",dT=(CatBins$newMinPerBin*60),col='orange',xlab="")
  #getMT = spec.mtm(DataList[cnt,],main="",dtUnits="second",dT=(CatBins$newMinPerBin*60),col='orange',xlab="")
    #series <- deparse(substitute(timeSeries))
    #taper <- match.arg(taper,c("dpss","sine"))
    #centre <- match.arg(centre,c("Slepian","arithMean","trimMean","none"))
    #dtUnits <- match.arg(dtUnits,c("second","hour","day","month","year","default")) 
    #  if FTEST=true,  class(spec.out) <- c("mtm", "Ftest", "spec")
  #http://www.mathworks.com/help/signal/ug/spectral-analysis.html
  #as NW increases, there are more estimates of the power spectrum, and the variance 
  #of the estimate decreases. However, the bandwidth of each taper is also proportional to NW, 
  #so as NW increases, each estimate exhibits more spectral leakage (i.e., wider peaks) and the 
  #overall spectral estimate is more biased. For each data set, there is usually a value for NW 
  #that allows an optimal trade-off between bias and variance.
  
  minPt <- which.min(getMT$spec)
  minShow<-getMT$spec[minPt]
  MTpts<-length(getMT$freq)
  #   First maximum peak
  periodPt <- which.max(getMT$spec[1:(CatBins$binsPerDay/10+binPts*4)])        #which.max(getMT$spec[1:(binPts*4)])
  MTperiod <- getMT$spec[periodPt]
  
  #hrsPerPeriod = (periodPt/CatBins$binsPerDay)*24
  
  abline(h=MTperiod, col="grey")
  xPoint <- getMT$freq[periodPt]
  #text(x=(getMT$freq[MTpts])/3,y=(MTperiod*.9),paste("x=",xPoint,"\ny=",format(MTperiod,digits=8),"\n(1/x) =",format(1/xPoint,digits=8),"days/period \n",format((1/xPoint)*24,digits=8)," hrs"),cex=.7)
  text(x=(getMT$freq[MTpts])/3,y=(MTperiod*.9),paste("x=",xPoint,"\ny=",format(MTperiod,digits=8),"\n(1/x) =",format(1/xPoint,digits=8),"sec/period \n",format((1/xPoint)/(60*60),digits=8)," hrs"),cex=.7)
  points(x=xPoint,y=MTperiod , type="p",col="gray")
  points(x=xPoint,y=minShow , type="p",col="gray")
  
  #cat(" MTpts ",MTpts," ",MTpts*.0005, " ",periodPt)
  
  #  two vertical lines to bracket first peak width, as an aid to judge span of time it covers
  Xdiff<-diff(getMT$freq[(periodPt*.5):periodPt],1,1)
  Ydiff<-diff(getMT$spec[(periodPt*.5):periodPt],1,1)
  PeakSlope<-Xdiff/Ydiff
  v1<-getMT$freq[(periodPt*.5)+which.min(PeakSlope[PeakSlope>0])+2]
  abline(v=v1,  lty="dotted",col="gray40")
 
  Xdiff<-diff(getMT$freq[periodPt:(periodPt*1.5)],1,1)
  Ydiff<-diff(getMT$spec[periodPt:(periodPt*1.5)],1,1)
  PeakSlope<-Xdiff/Ydiff
  v2<-getMT$freq[periodPt+which.max(PeakSlope[PeakSlope<0])+2]    # adjust +2 for indexes lost in diff()
  abline(v=v2, lty="dotted",col="gray40")
  #text(x=(getMT$freq[MTpts])/4,y=((MTperiod-minShow) *.10),paste(" x1=",format(v1,digits=8),"\n1/x1=",format(1/v1,digits=8)," days, ",format((1/v1)*24,digits=8)," hrs\nx2 =",format(v2,digits=8),"\n 1/x2 =",format(1/v2,digits=8)" days, ",format((1/v2)*24,digits=8)," hrs"),cex=.7)
  text(x=(getMT$freq[MTpts])/4,y=((MTperiod-minShow) *.10),paste(" x1=",format(v1,digits=8),"\n1/x1=",format(1/v1,digits=8)," sec, ",format((1/v1)/(60*60),digits=8)," hrs\nx2 =",format(v2,digits=8),"\n 1/x2 =",format(1/v2,digits=8)," sec, ",format((1/v2)/(60*60),digits=8)," hrs"),cex=.7)
  
  peakRange<-CatBins$binsPerDay/10+binPts         #MTpts*.04  #  old = binPts  .01 is bad   .05 works really well for 5 days, fair for 22 days
  # 2nd max peak:  starting from (1st point + # points in a bin) to the end
  periodPtRelative <- which.max(getMT$spec[(periodPt+peakRange):(MTpts)])         #-(1:(periodPt+15))
  periodPt2<-periodPtRelative + periodPt + peakRange - 1
  MTperiod2 <- getMT$spec[periodPt2]
  abline(h=MTperiod2, col="cornflowerblue")
  xPoint2 <- getMT$freq[periodPt2]
  text(x=(getMT$freq[MTpts])/1.6,y=(MTperiod2*.9),paste("x=",xPoint2,"\ny=",format(MTperiod2,digits=8),"\n(1/x) =",format(1/xPoint2,digits=8),"sec/period\n",format((1/xPoint2)/(60*60),digits=8)," hrs"),cex=.6, col="cornflowerblue")
  points(x=xPoint2,y=MTperiod2,  type="p",col="cornflowerblue")
  points(x=xPoint2,y=minShow,  type="p",col="cornflowerblue")
  
  # 3rd max peak:  starting from (2nd point + # points in a bin) to the end
  periodPtRelative <- which.max(getMT$spec[(periodPt2+peakRange):(MTpts)])         #-(1:(periodPt+15))
  periodPt3<-periodPtRelative + periodPt2 + peakRange - 1
  
  MTperiod3 <- getMT$spec[periodPt3]
  abline(h=MTperiod3, col="aquamarine4")
  xPoint3 <- getMT$freq[periodPt3]
  text(x=(getMT$freq[MTpts])/1.1,y=(MTperiod3*.9),paste("x=",xPoint3,"\ny=",format(MTperiod3,digits=8),"\n(1/x) =",format(1/xPoint3,digits=8),"sec/period\n",format((1/xPoint3)/(60*60),digits=8)," hrs"),cex=.6, col="aquamarine4")
  points(x=xPoint3,y=MTperiod3,  type="p",col="cornflowerblue")
  points(x=xPoint3,y=minShow,  type="p",col="aquamarine4")
  
  
  mtext(paste("Frequency in cycles/day;  NW=",NWmtm, "K=",Kmtm,";    Max: data point ",periodPt),cex=.8,line=2,side=1)
  
  #plot(getMT, Ftest=TRUE)
  mtext(paste('Total bins: ',CatBins$dataPts/binPts,';     pts/bin: ',binPts,'(',CatBins$newMinPerBin,'mins);     bins/day: ',CatBins$binsPerDay),cex=.7,line=3,side=1)
  mtext(paste("Span:",Span," Inc:",Increment),side=1,line = 4, cex =.4, adj=.1)
  mtext(paste(fileName,"   ",thisTime),side=1,line = 4, cex =.4, adj=.9)
  
}  # end for (cnt in 1:plotCnt)
  #remove read only list components 
  op$cin<-NULL
  op$cra<-NULL
  op$csi<-NULL
  op$cxy<-NULL
  op$din<-NULL
  op$page<-NULL
  par(op)
end
}
